Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callcorrk.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callcorrk.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callcorrk.F90	(revision 227)
@@ -12,5 +12,6 @@
       use watercommon_h
       use datafile_mod, only: datadir
-      use ioipsl_getincom 
+!      use ioipsl_getincom 
+      use ioipsl_getincom_p
       use gases_h
       use radii_mod, only : su_aer_radii,co2_reffrad,h2o_reffrad,dust_reffrad,h2so4_reffrad,back2lay_reffrad
@@ -35,5 +36,5 @@
 !==================================================================
 
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -42,5 +43,5 @@
 !     Declaration of the arguments (INPUT - OUTPUT) on the LMD GCM grid
 !     Layer #1 is the layer near the ground. 
-!     Layer #nlayermx is the layer at the top.
+!     Layer #nlayer is the layer at the top.
 
       INTEGER,INTENT(IN) :: ngrid ! number of atmospheric columns
@@ -52,14 +53,14 @@
       REAL,INTENT(IN) :: emis(ngrid)     ! LW emissivity
       real,intent(in) :: mu0(ngrid) ! cosine of sun incident angle
-      REAL,INTENT(IN) :: pplev(ngrid,nlayermx+1)  ! inter-layer pressure (Pa)
-      REAL,INTENT(IN) :: pplay(ngrid,nlayermx)    ! mid-layer pressure (Pa)
-      REAL,INTENT(IN) :: pt(ngrid,nlayermx)  ! air temperature (K)
+      REAL,INTENT(IN) :: pplev(ngrid,nlayer+1)  ! inter-layer pressure (Pa)
+      REAL,INTENT(IN) :: pplay(ngrid,nlayer)    ! mid-layer pressure (Pa)
+      REAL,INTENT(IN) :: pt(ngrid,nlayer)  ! air temperature (K)
       REAL,INTENT(IN) :: tsurf(ngrid)        ! surface temperature (K)
       REAL,INTENT(IN) :: fract(ngrid)        ! fraction of day
       REAL,INTENT(IN) :: dist_star           ! distance star-planet (AU)
-      REAL,INTENT(OUT) :: aerosol(ngrid,nlayermx,naerkind) ! aerosol tau (kg/kg)
-      real,intent(in) :: muvar(ngrid,nlayermx+1)
-      REAL,INTENT(OUT) :: dtlw(ngrid,nlayermx) ! heating rate (K/s) due to LW
-      REAL,INTENT(OUT) :: dtsw(ngrid,nlayermx) ! heating rate (K/s) due to SW
+      REAL,INTENT(OUT) :: aerosol(ngrid,nlayer,naerkind) ! aerosol tau (kg/kg)
+      real,intent(in) :: muvar(ngrid,nlayer+1)
+      REAL,INTENT(OUT) :: dtlw(ngrid,nlayer) ! heating rate (K/s) due to LW
+      REAL,INTENT(OUT) :: dtsw(ngrid,nlayer) ! heating rate (K/s) due to SW
       REAL,INTENT(OUT) :: fluxsurf_lw(ngrid)   ! incident LW flux to surf (W/m2)
       REAL,INTENT(OUT) :: fluxsurf_sw(ngrid)   ! incident SW flux to surf (W/m2)
@@ -71,5 +72,5 @@
       REAL,INTENT(OUT) :: tau_col(ngrid) ! diagnostic from aeropacity
 !     for H2O cloud fraction in aeropacity
-      real,intent(in) :: cloudfrac(ngrid,nlayermx)
+      real,intent(in) :: cloudfrac(ngrid,nlayer)
       real,intent(out) :: totcloudfrac(ngrid)
       logical,intent(in) :: clearsky
@@ -79,17 +80,18 @@
 !     Globally varying aerosol optical properties on GCM grid
 !     Not needed everywhere so not in radcommon_h
-      REAL :: QVISsQREF3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-      REAL :: omegaVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-      REAL :: gVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-
-      REAL :: QIRsQREF3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-      REAL :: omegaIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-      REAL :: gIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-
-!      REAL :: omegaREFvis3d(ngrid,nlayermx,naerkind)
-!      REAL :: omegaREFir3d(ngrid,nlayermx,naerkind) ! not sure of the point of these...
+      REAL :: QVISsQREF3d(ngrid,nlayer,L_NSPECTV,naerkind)
+      REAL :: omegaVIS3d(ngrid,nlayer,L_NSPECTV,naerkind)
+      REAL :: gVIS3d(ngrid,nlayer,L_NSPECTV,naerkind)
+
+      REAL :: QIRsQREF3d(ngrid,nlayer,L_NSPECTI,naerkind)
+      REAL :: omegaIR3d(ngrid,nlayer,L_NSPECTI,naerkind)
+      REAL :: gIR3d(ngrid,nlayer,L_NSPECTI,naerkind)
+
+!      REAL :: omegaREFvis3d(ngrid,nlayer,naerkind)
+!      REAL :: omegaREFir3d(ngrid,nlayer,naerkind) ! not sure of the point of these...
 
       REAL,ALLOCATABLE,SAVE :: reffrad(:,:,:) ! aerosol effective radius (m)
       REAL,ALLOCATABLE,SAVE :: nueffrad(:,:,:) ! aerosol effective variance
+!$OMP THREADPRIVATE(reffrad,nueffrad)
 
 !-----------------------------------------------------------------------
@@ -128,4 +130,5 @@
       logical global1d
       save szangle,global1d
+!$OMP THREADPRIVATE(szangle,global1d)
       real*8 taugsurf(L_NSPECTV,L_NGAUSS-1)
       real*8 taugsurfi(L_NSPECTI,L_NGAUSS-1)
@@ -141,9 +144,10 @@
       real*8,save ::  GIAER(L_LEVELS+1,L_NSPECTI,naerkind)
 
-      !REAL :: QREFvis3d(ngrid,nlayermx,naerkind)
-      !REAL :: QREFir3d(ngrid,nlayermx,naerkind)
+      !REAL :: QREFvis3d(ngrid,nlayer,naerkind)
+      !REAL :: QREFir3d(ngrid,nlayer,naerkind)
       !save QREFvis3d, QREFir3d 
       real, dimension(:,:,:), save, allocatable :: QREFvis3d
       real, dimension(:,:,:), save, allocatable :: QREFir3d
+!$OMP THREADPRIVATE(QXVAER,QSVAER,GVAER,QXIAER,QSIAER,GIAER,QREFvis3d,QREFir3d)
 
 
@@ -177,5 +181,5 @@
 
 !     included by RW for runaway greenhouse 1D study
-      real vtmp(nlayermx)
+      real vtmp(nlayer)
       REAL*8 muvarrad(L_LEVELS)
 
@@ -195,6 +199,6 @@
          !!! ALLOCATED instances are necessary because of CLFvarying
          !!! strategy to call callcorrk twice in physiq...
-         IF(.not.ALLOCATED(QREFvis3d)) ALLOCATE(QREFvis3d(ngrid,nlayermx,naerkind))
-         IF(.not.ALLOCATED(QREFir3d)) ALLOCATE(QREFir3d(ngrid,nlayermx,naerkind))
+         IF(.not.ALLOCATED(QREFvis3d)) ALLOCATE(QREFvis3d(ngrid,nlayer,naerkind))
+         IF(.not.ALLOCATED(QREFir3d)) ALLOCATE(QREFir3d(ngrid,nlayer,naerkind))
          ! Effective radius and variance of the aerosols
          IF(.not.ALLOCATED(reffrad)) allocate(reffrad(ngrid,nlayer,naerkind))
@@ -207,5 +211,5 @@
             call abort
          endif
-         call su_aer_radii(ngrid,reffrad,nueffrad)
+         call su_aer_radii(ngrid,nlayer,reffrad,nueffrad)
 	 
 	 
@@ -214,5 +218,5 @@
 !     set up correlated k
          print*, "callcorrk: Correlated-k data base folder:",trim(datadir)
-         call getin("corrkdir",corrkdir)
+         call getin_p("corrkdir",corrkdir)
          print*, "corrkdir = ",corrkdir
          write( tmp1, '(i3)' ) L_NSPECTI
@@ -238,5 +242,5 @@
            PRINT*, 'Simulate global averaged conditions ?'
            global1d = .false. ! default value
-           call getin("global1d",global1d)
+           call getin_p("global1d",global1d)
            write(*,*) "global1d = ",global1d
            ! Test of incompatibility:
@@ -251,5 +255,5 @@
              PRINT *,'(assumed for averaged solar flux S/4)'
              szangle=60.0  ! default value
-             call getin("szangle",szangle)
+             call getin_p("szangle",szangle)
              write(*,*) "szangle = ",szangle
            endif
@@ -266,20 +270,20 @@
 
          if ((iaer.eq.iaero_co2).and.tracer.and.(igcm_co2_ice.gt.0)) then ! treat condensed co2 particles.
-	    call co2_reffrad(ngrid,nq,pq,reffrad(1,1,iaero_co2))
-            print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
-            print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
+	    call co2_reffrad(ngrid,nlayer,nq,pq,reffrad(1,1,iaero_co2))
+            print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
+            print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
 	 end if
          if ((iaer.eq.iaero_h2o).and.water) then ! treat condensed water particles. to be generalized for other aerosols
-	    call h2o_reffrad(ngrid,pq(1,1,igcm_h2o_ice),pt, &
+	    call h2o_reffrad(ngrid,nlayer,pq(1,1,igcm_h2o_ice),pt, &
                              reffrad(1,1,iaero_h2o),nueffrad(1,1,iaero_h2o))
-            print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
-            print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
+            print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
+            print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
          endif
          if(iaer.eq.iaero_dust)then
-	    call dust_reffrad(ngrid,reffrad(1,1,iaero_dust))
+	    call dust_reffrad(ngrid,nlayer,reffrad(1,1,iaero_dust))
             print*,'Dust particle size = ',reffrad(1,1,iaer)/1.e-6,' um'
          endif
          if(iaer.eq.iaero_h2so4)then
-	    call h2so4_reffrad(ngrid,reffrad(1,1,iaero_h2so4))
+	    call h2so4_reffrad(ngrid,nlayer,reffrad(1,1,iaero_h2so4))
             print*,'H2SO4 particle size =',reffrad(1,1,iaer)/1.e-6,' um'
          endif
@@ -318,23 +322,23 @@
             do iaer=1,naerkind
                DO nw=1,L_NSPECTV 
-                  do l=1,nlayermx
-
-                     temp1=QVISsQREF3d(ig,nlayermx+1-l,nw,iaer)         &
-                         *QREFvis3d(ig,nlayermx+1-l,iaer)
-
-                     temp2=QVISsQREF3d(ig,max(nlayermx-l,1),nw,iaer)    &
-                         *QREFvis3d(ig,max(nlayermx-l,1),iaer)
+                  do l=1,nlayer
+
+                     temp1=QVISsQREF3d(ig,nlayer+1-l,nw,iaer)         &
+                         *QREFvis3d(ig,nlayer+1-l,iaer)
+
+                     temp2=QVISsQREF3d(ig,max(nlayer-l,1),nw,iaer)    &
+                         *QREFvis3d(ig,max(nlayer-l,1),iaer)
 
                      qxvaer(2*l,nw,iaer)  = temp1
                      qxvaer(2*l+1,nw,iaer)=(temp1+temp2)/2
 
-                     temp1=temp1*omegavis3d(ig,nlayermx+1-l,nw,iaer)
-                     temp2=temp2*omegavis3d(ig,max(nlayermx-l,1),nw,iaer)
+                     temp1=temp1*omegavis3d(ig,nlayer+1-l,nw,iaer)
+                     temp2=temp2*omegavis3d(ig,max(nlayer-l,1),nw,iaer)
 
                      qsvaer(2*l,nw,iaer)  = temp1
                      qsvaer(2*l+1,nw,iaer)=(temp1+temp2)/2
 
-                     temp1=gvis3d(ig,nlayermx+1-l,nw,iaer)
-                     temp2=gvis3d(ig,max(nlayermx-l,1),nw,iaer)
+                     temp1=gvis3d(ig,nlayer+1-l,nw,iaer)
+                     temp2=gvis3d(ig,max(nlayer-l,1),nw,iaer)
 
                      gvaer(2*l,nw,iaer)  = temp1
@@ -344,11 +348,11 @@
 
                   qxvaer(1,nw,iaer)=qxvaer(2,nw,iaer)
-                  qxvaer(2*nlayermx+1,nw,iaer)=0.
+                  qxvaer(2*nlayer+1,nw,iaer)=0.
 
                   qsvaer(1,nw,iaer)=qsvaer(2,nw,iaer)
-                  qsvaer(2*nlayermx+1,nw,iaer)=0.
+                  qsvaer(2*nlayer+1,nw,iaer)=0.
 
                   gvaer(1,nw,iaer)=gvaer(2,nw,iaer)
-                  gvaer(2*nlayermx+1,nw,iaer)=0.
+                  gvaer(2*nlayer+1,nw,iaer)=0.
 
                end do
@@ -356,23 +360,23 @@
 !     longwave
                DO nw=1,L_NSPECTI 
-                  do l=1,nlayermx
-
-                     temp1=QIRsQREF3d(ig,nlayermx+1-l,nw,iaer)         &
-                          *QREFir3d(ig,nlayermx+1-l,iaer)
-
-                     temp2=QIRsQREF3d(ig,max(nlayermx-l,1),nw,iaer)    &
-                          *QREFir3d(ig,max(nlayermx-l,1),iaer)
+                  do l=1,nlayer
+
+                     temp1=QIRsQREF3d(ig,nlayer+1-l,nw,iaer)         &
+                          *QREFir3d(ig,nlayer+1-l,iaer)
+
+                     temp2=QIRsQREF3d(ig,max(nlayer-l,1),nw,iaer)    &
+                          *QREFir3d(ig,max(nlayer-l,1),iaer)
 
                      qxiaer(2*l,nw,iaer)  = temp1
                      qxiaer(2*l+1,nw,iaer)=(temp1+temp2)/2
 
-                     temp1=temp1*omegair3d(ig,nlayermx+1-l,nw,iaer)
-                     temp2=temp2*omegair3d(ig,max(nlayermx-l,1),nw,iaer)
+                     temp1=temp1*omegair3d(ig,nlayer+1-l,nw,iaer)
+                     temp2=temp2*omegair3d(ig,max(nlayer-l,1),nw,iaer)
 
                      qsiaer(2*l,nw,iaer)  = temp1
                      qsiaer(2*l+1,nw,iaer)=(temp1+temp2)/2
 
-                     temp1=gir3d(ig,nlayermx+1-l,nw,iaer)
-                     temp2=gir3d(ig,max(nlayermx-l,1),nw,iaer)
+                     temp1=gir3d(ig,nlayer+1-l,nw,iaer)
+                     temp2=gir3d(ig,max(nlayer-l,1),nw,iaer)
 
                      giaer(2*l,nw,iaer)  = temp1
@@ -382,11 +386,11 @@
 
                   qxiaer(1,nw,iaer)=qxiaer(2,nw,iaer)
-                  qxiaer(2*nlayermx+1,nw,iaer)=0.
+                  qxiaer(2*nlayer+1,nw,iaer)=0.
 
                   qsiaer(1,nw,iaer)=qsiaer(2,nw,iaer)
-                  qsiaer(2*nlayermx+1,nw,iaer)=0.
+                  qsiaer(2*nlayer+1,nw,iaer)=0.
 
                   giaer(1,nw,iaer)=giaer(2,nw,iaer)
-                  giaer(2*nlayermx+1,nw,iaer)=0.
+                  giaer(2*nlayer+1,nw,iaer)=0.
 
                end do
@@ -481,5 +485,5 @@
       elseif(varfixed)then
 
-         do l=1,nlayermx        ! here we will assign fixed water vapour profiles globally
+         do l=1,nlayer        ! here we will assign fixed water vapour profiles globally
             RH = satval * ((pplay(ig,l)/pplev(ig,1) - 0.02) / 0.98)
             if(RH.lt.0.0) RH=0.0
@@ -507,5 +511,5 @@
 !         call watersat(Ttemp,ptemp,qsat)
 
-         qvar(2*nlayermx+1)= RH * qsat ! ~realistic profile (e.g. 80% saturation at ground)
+         qvar(2*nlayer+1)= RH * qsat ! ~realistic profile (e.g. 80% saturation at ground)
  
       else
@@ -541,5 +545,5 @@
       
             muvarrad(1) = muvarrad(2)
-            muvarrad(2*nlayermx+1)=muvar(ig,1)
+            muvarrad(2*nlayer+1)=muvar(ig,1)
 
             print*,'Recalculating qvar with VARIABLE epsi for kastprof'
@@ -579,5 +583,5 @@
       
          muvarrad(1) = muvarrad(2)
-         muvarrad(2*nlayermx+1)=muvar(ig,1)         
+         muvarrad(2*nlayer+1)=muvar(ig,1)         
       endif
       
@@ -607,5 +611,5 @@
 
       tlevrad(1) = tlevrad(2)
-      tlevrad(2*nlayermx+1)=tsurf(ig)
+      tlevrad(2*nlayer+1)=tsurf(ig)
       
       tmid(1) = tlevrad(2)
@@ -866,8 +870,12 @@
         IF( ALLOCATED( gasi ) ) DEALLOCATE( gasi )
         IF( ALLOCATED( gasv ) ) DEALLOCATE( gasv )
+!$OMP BARRIER
+!$OMP MASTER
         IF( ALLOCATED( pgasref ) ) DEALLOCATE( pgasref )
         IF( ALLOCATED( tgasref ) ) DEALLOCATE( tgasref )
         IF( ALLOCATED( wrefvar ) ) DEALLOCATE( wrefvar )
         IF( ALLOCATED( pfgasref ) ) DEALLOCATE( pfgasref )
+!$OMP END MASTER
+!$OMP BARRIER	
         IF ( ALLOCATED(reffrad)) DEALLOCATE(reffrad)
         IF ( ALLOCATED(nueffrad)) DEALLOCATE(nueffrad)
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callkeys.h
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callkeys.h	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callkeys.h	(revision 227)
@@ -117,2 +117,4 @@
       real J2
       real MassPlanet
+      
+      logical :: iscallphys=.false.!existence of callphys.def
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callsedim.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callsedim.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/callsedim.F	(revision 227)
@@ -28,6 +28,6 @@
 c   -------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -65,8 +65,9 @@
       real epaisseur (ngrid,nlay) ! Layer thickness (m)
       real wq(ngrid,nlay+1) ! displaced tracer mass (kg.m-2)
-c      real dens(ngrid,nlayermx) ! Mean density of the ice part. accounting for dust core
+c      real dens(ngrid,nlay) ! Mean density of the ice part. accounting for dust core
 
 
       LOGICAL,SAVE :: firstcall=.true.
+!$OMP THREADPRIVATE(firstcall)
 
 c    ** un petit test de coherence
@@ -125,5 +126,5 @@
           if (water.and.(iq.eq.igcm_h2o_ice)) then
             ! compute radii for h2o_ice 
-             call h2o_reffrad(ngrid,zqi(1,1,igcm_h2o_ice),zt,
+             call h2o_reffrad(ngrid,nlay,zqi(1,1,igcm_h2o_ice),zt,
      &                reffrad(1,1,iaero_h2o),nueffrad(1,1,iaero_h2o))
             ! call sedimentation for h2o_ice
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comdiurn_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comdiurn_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comdiurn_h.F90	(revision 227)
@@ -6,4 +6,5 @@
        real, allocatable, dimension(:) :: sinlon, coslon, sinlat, coslat
        logical :: ldiurn
+!$OMP THREADPRIVATE(sinlon,coslon,sinlat,coslat,ldiurn) !ldiurn is unused
 
        end module comdiurn_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comgeomfi_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comgeomfi_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comgeomfi_h.F90	(revision 227)
@@ -6,4 +6,5 @@
        REAL,ALLOCATABLE,DIMENSION(:) :: long,lati,area
        REAL :: totarea, totarea_planet
+!$OMP THREADPRIVATE(long,lati,area,totarea)
 
        end module comgeomfi_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comsaison_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comsaison_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comsaison_h.F90	(revision 227)
@@ -9,4 +9,5 @@
 
        real, allocatable, dimension(:) :: mu0,fract
+!$OMP THREADPRIVATE(isaison,callsais,dist_star,declin,mu0,fract)
 
        end module comsaison_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comsoil_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comsoil_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/comsoil_h.F90	(revision 227)
@@ -14,4 +14,5 @@
        !     in physdem (or set via tabfi, or initialized in
        !                 soil_settings.F)
+!$OMP THREADPRIVATE(layer,mlayer,inertiedat,volcapa)
 
 contains
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/condense_cloud.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/condense_cloud.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/condense_cloud.F90	(revision 227)
@@ -32,5 +32,5 @@
 !     ptsrf(ngrid)          Surface temperature
 !     
-!     pdt(ngrid,nlayermx)   Time derivative before condensation/sublimation of pt
+!     pdt(ngrid,nlayer)   Time derivative before condensation/sublimation of pt
 !     pdtsrf(ngrid)         Time derivative before condensation/sublimation of ptsrf
 !     pqsurf(ngrid,nq)      Sedimentation flux at the surface (kg.m-2.s-1)
@@ -38,7 +38,7 @@
 !     Outputs
 !     -------
-!     pdpsrf(ngrid)         \  Contribution of condensation/sublimation
-!     pdtc(ngrid,nlayermx)  /  to the time derivatives of Ps, pt, and ptsrf
-!     pdtsrfc(ngrid)       /
+!     pdpsrf(ngrid)       \  Contribution of condensation/sublimation
+!     pdtc(ngrid,nlayer)  /  to the time derivatives of Ps, pt, and ptsrf
+!     pdtsrfc(ngrid)     /
 !     
 !     Both
@@ -56,8 +56,8 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
-#include "comvert.h"
+!#include "comvert.h"
 #include "callkeys.h"
 
@@ -99,30 +99,30 @@
 
       REAL reffrad(ngrid,nlayer) ! radius (m) of the co2 ice particles
-      REAL*8 zt(ngrid,nlayermx)
-      REAL zq(ngrid,nlayermx,nq)
+      REAL*8 zt(ngrid,nlayer)
+      REAL zq(ngrid,nlayer,nq)
       REAL zcpi
-      REAL ztcond (ngrid,nlayermx)
-      REAL ztnuc (ngrid,nlayermx)
+      REAL ztcond (ngrid,nlayer)
+      REAL ztnuc (ngrid,nlayer)
       REAL ztcondsol(ngrid) 
       REAL zdiceco2(ngrid)
-      REAL zcondicea(ngrid,nlayermx), zcondices(ngrid)
+      REAL zcondicea(ngrid,nlayer), zcondices(ngrid)
       REAL zfallice(ngrid), Mfallice(ngrid) 
-      REAL zmflux(nlayermx+1)
-      REAL zu(nlayermx),zv(nlayermx)
+      REAL zmflux(nlayer+1)
+      REAL zu(nlayer),zv(nlayer)
       REAL ztsrf(ngrid)
-      REAL ztc(nlayermx), ztm(nlayermx+1) 
-      REAL zum(nlayermx+1) , zvm(nlayermx+1)
+      REAL ztc(nlayer), ztm(nlayer+1) 
+      REAL zum(nlayer+1) , zvm(nlayer+1)
       LOGICAL condsub(ngrid)
       REAL subptimestep
       Integer Ntime
-      real masse (ngrid,nlayermx), w(ngrid,nlayermx,nq)
-      real wq(ngrid,nlayermx+1)
+      real masse (ngrid,nlayer), w(ngrid,nlayer,nq)
+      real wq(ngrid,nlayer+1)
       real vstokes,reff
 
 !     Special diagnostic variables
-      real tconda1(ngrid,nlayermx)
-      real tconda2(ngrid,nlayermx)
-      real zdtsig (ngrid,nlayermx)
-      real zdt (ngrid,nlayermx)
+      real tconda1(ngrid,nlayer)
+      real tconda2(ngrid,nlayer)
+      real zdtsig (ngrid,nlayer)
+      real zdt (ngrid,nlayer)
 
 !-----------------------------------------------------------------------
@@ -133,6 +133,8 @@
       REAL,SAVE :: cpice=1000.
       REAL,SAVE,ALLOCATABLE,DIMENSION(:) :: emisref
+!$OMP THREADPRIVATE(latcond,ccond,cpice,emisref)
 
       LOGICAL,SAVE :: firstcall=.true.
+!$OMP THREADPRIVATE(firstcall)
       REAL,EXTERNAL :: SSUM
 
@@ -140,4 +142,5 @@
 
       INTEGER,SAVE :: i_co2ice=0      ! co2 ice
+!$OMP THREADPRIVATE(i_co2ice)
       CHARACTER(LEN=20) :: tracername ! to temporarily store text
 
@@ -205,5 +208,5 @@
 !     zcondices(ngrid)     condensation rate on the ground  (kg/m2/s)
 !     zfallice(ngrid)      flux of ice falling on surface   (kg/m2/s)
-!     pdtc(ngrid,nlayermx) dT/dt due to phase changes       (K/s)
+!     pdtc(ngrid,nlayer) dT/dt due to phase changes       (K/s)
      
 
@@ -301,5 +304,5 @@
             
 !     sedimentation computed from radius computed from q in module radii_mod
-	 call co2_reffrad(ngrid,nq,zq,reffrad)
+	 call co2_reffrad(ngrid,nlayer,nq,zq,reffrad)
 	 
          do  ilay=1,nlayer
@@ -321,5 +324,5 @@
 !     Computing q after sedimentation
 
-         call vlz_fi(ngrid,zq(1,1,i_co2ice),2.,masse,w(1,1,i_co2ice),wq)
+         call vlz_fi(ngrid,nlayer,zq(1,1,i_co2ice),2.,masse,w(1,1,i_co2ice),wq)
 
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/convadj.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/convadj.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/convadj.F	(revision 227)
@@ -29,6 +29,6 @@
 !     ------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -57,9 +57,9 @@
       INTEGER jcnt, jadrs(ngrid)
 
-      REAL sig(nlayermx+1),sdsig(nlayermx),dsig(nlayermx)
-      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
-      REAL zh(ngrid,nlayermx)
-      REAL zu2(ngrid,nlayermx),zv2(ngrid,nlayermx)
-      REAL zh2(ngrid,nlayermx), zhc(ngrid,nlayermx)
+      REAL sig(nlay+1),sdsig(nlay),dsig(nlay)
+      REAL zu(ngrid,nlay),zv(ngrid,nlay)
+      REAL zh(ngrid,nlay)
+      REAL zu2(ngrid,nlay),zv2(ngrid,nlay)
+      REAL zh2(ngrid,nlay), zhc(ngrid,nlay)
       REAL zhm,zsm,zdsm,zum,zvm,zalpha,zhmc
 
@@ -67,8 +67,10 @@
       INTEGER iq,ico2
       save ico2
-      REAL zq(ngrid,nlayermx,nq), zq2(ngrid,nlayermx,nq)
+!$OMP THREADPRIVATE(ico2)
+      REAL zq(ngrid,nlay,nq), zq2(ngrid,nlay,nq)
       REAL zqm(nq),zqco2m
       real m_co2, m_noco2, A , B
       save A, B
+!$OMP THREADPRIVATE(A,B)
 
       real mtot1, mtot2 , mm1, mm2
@@ -77,4 +79,5 @@
       save firstcall
       data firstcall/.true./
+!$OMP THREADPRIVATE(firstcall)
 
 !     for conservation test
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/dimphy.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/dimphy.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/dimphy.F90	(revision 227)
@@ -2,7 +2,7 @@
   
   INTEGER,SAVE :: klon   ! number of atmospheric columns (for this OpenMP subgrid)
-  INTEGER,SAVE :: klev   ! number of atmospheric layers
-  INTEGER,SAVE :: klevp1 ! number of atmospheric layers+1
-  INTEGER,SAVE :: klevm1 ! number of atmospheric layers-1
+  INTEGER,SAVE :: klev   ! number of atmospheric layers, read by master
+  INTEGER,SAVE :: klevp1 ! number of atmospheric layers+1, read by master
+  INTEGER,SAVE :: klevm1 ! number of atmospheric layers-1, read by master
 !  INTEGER,SAVE :: kflev
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/evap.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/evap.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/evap.F	(revision 227)
@@ -1,3 +1,3 @@
-      subroutine evap(ngrid,nq,dtime,pt, pq, pdq, pdt,  
+      subroutine evap(ngrid,nlayer,nq,dtime,pt, pq, pdq, pdt,  
      $     dqevap,dtevap, qevap, tevap) 
         
@@ -7,6 +7,6 @@
       implicit none
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 
@@ -24,18 +24,18 @@
 !==================================================================
 
-      INTEGER ngrid,nq
+      INTEGER ngrid,nlayer,nq
 
 ! Arguments:
-      REAL pt(ngrid,nlayermx) 
-      REAL pq(ngrid,nlayermx,nq) 
-      REAL pdt(ngrid,nlayermx) 
-      REAL pdq(ngrid,nlayermx,nq) 
-      REAL dqevap(ngrid,nlayermx)
-      REAL dtevap(ngrid,nlayermx)
-      REAL qevap(ngrid,nlayermx,nq)
+      REAL pt(ngrid,nlayer) 
+      REAL pq(ngrid,nlayer,nq) 
+      REAL pdt(ngrid,nlayer) 
+      REAL pdq(ngrid,nlayer,nq) 
+      REAL dqevap(ngrid,nlayer)
+      REAL dtevap(ngrid,nlayer)
+      REAL qevap(ngrid,nlayer,nq)
       REAL dtime
  
 ! Local:
-      REAL tevap(ngrid,nlayermx) 
+      REAL tevap(ngrid,nlayer) 
       REAL zlvdcp
       REAL zlsdcp
@@ -47,5 +47,5 @@
 !
 
-      DO l=1,nlayermx
+      DO l=1,nlayer
         DO ig=1,ngrid
          qevap(ig,l,igcm_h2o_vap)=pq(ig,l,igcm_h2o_vap)	
@@ -57,5 +57,5 @@
       ENDDO
 
-      DO l = 1, nlayermx  
+      DO l = 1, nlayer
       	DO ig = 1, ngrid
          zlvdcp=RLVTT/RCPD!/(1.0+RVTMP2*qevap(ig,l,igcm_h2o_vap))
@@ -77,4 +77,3 @@
       ENDDO
 
-      RETURN
       END
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/forceWCfn.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/forceWCfn.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/forceWCfn.F	(revision 227)
@@ -1,3 +1,3 @@
-      subroutine forceWCfn(ngrid,nq,pplev,pt,dq,dqs)
+      subroutine forceWCfn(ngrid,nlayer,nq,pplev,pt,dq,dqs)
 
       USE tracer_h
@@ -18,17 +18,17 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 
-      INTEGER ngrid,nq
+      INTEGER ngrid,nlayer,nq
 
       real masse, Wtot, Wdiff
 
-      real pplev(ngrid,nlayermx+1)
+      real pplev(ngrid,nlayer+1)
       real pt(ngrid)
 
       real dqs(ngrid,nq) 
-      real dq(ngrid,nlayermx,nq)
+      real dq(ngrid,nlayer,nq)
 
       integer iq, ig, ilay
@@ -37,5 +37,5 @@
         do ig=1,ngrid
            Wtot = 0.0
-           do ilay=1,nlayermx
+           do ilay=1,nlayer
               masse = (pplev(ig,ilay) - pplev(ig,ilay+1))/g
               Wtot  = Wtot + masse*dq(ig,ilay,iq)
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/gases_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/gases_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/gases_h.F90	(revision 227)
@@ -14,5 +14,5 @@
       integer :: ngasmx
       integer :: vgas
-      character*20,allocatable,DIMENSION(:) :: gnom ! name of the gas
+      character*20,allocatable,DIMENSION(:) :: gnom ! name of the gas, read by master
       real,allocatable,DIMENSION(:) :: gfrac
 
@@ -31,4 +31,7 @@
       integer :: igas_C2H2
       integer :: igas_C2H6
+!!$OMP THREADPRIVATE(ngasmx,vgas,gnom,gfrac,&
+!	!$OMP igas_H2,igas_He,igas_H2O,igas_CO2,igas_CO,igas_N2,&
+!	!$OMP igas_O2,igas_SO2,igas_H2S,igas_CH4,igas_NH3,igas_C2H2,igas_C2H6)
 
       end module gases_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/hydrol.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/hydrol.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/hydrol.F90	(revision 227)
@@ -4,5 +4,6 @@
      pctsrf_sic,sea_ice)
 
-  use ioipsl_getincom 
+!  use ioipsl_getincom 
+  use ioipsl_getincom_p
   use watercommon_h, only: T_h2O_ice_liq, RLFTT, rhowater, mx_eau_sol
   USE surfdat_h
@@ -39,6 +40,6 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -50,4 +51,5 @@
       real albedoice
       save albedoice
+!$OMP THREADPRIVATE(albedoice)
 
       real snowlayer
@@ -59,4 +61,5 @@
       logical,save :: activerunoff ! enable simple runoff scheme?
       logical,save :: oceanalbvary ! ocean albedo varies with the diurnal cycle?
+!$OMP THREADPRIVATE(oceanbulkavg,activerunoff,oceanalbvary)
 
 !     Arguments
@@ -66,4 +69,5 @@
       real totalrunoff, tsea, oceanarea
       save oceanarea
+!$OMP THREADPRIVATE(runoff,oceanarea)
 
       real ptimestep
@@ -96,6 +100,8 @@
 
       integer, save :: ivap, iliq, iice
+!$OMP THREADPRIVATE(ivap,iliq,iice)
 
       logical, save :: firstcall
+!$OMP THREADPRIVATE(firstcall)
 
       data firstcall /.true./
@@ -108,5 +114,5 @@
          write(*,*)"Activate runnoff into oceans?"
          activerunoff=.false.
-         call getin("activerunoff",activerunoff)
+         call getin_p("activerunoff",activerunoff)
          write(*,*)" activerunoff = ",activerunoff
 	 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/ini_archive.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/ini_archive.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/ini_archive.F	(revision 227)
@@ -40,5 +40,5 @@
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 #include "comconst.h"
